package vocleditor.dialogs;
import java.util.Vector;

import VOCLModel.NavExp;
/**
 * 
 * Class       : AttributeDialogInterface<br/>
 * Package     : vocleditor.dialog<br/>
 * Project     : VOCLEditor<br/>
 * Created On  : 26.06.2004<br/>
 * Description : <br/>
 * @author Gruppe 1: Stefan Hnsgen, 
 * 					 Andre Hernich,
 * 			 		 Maximilian Kern,
 *		 			 Sebastian Russin<br>
 */
public interface AttributeDialogInterface {
	
	/**
	 * Returns the current Navigationexpression.
	 * @return the Navigationexpression
	 */
	public NavExp getNavExp();
	
	
	/**
	 * Returns a list of Attributes.
	 * @return list of Attributes
	 */
	public Vector getAttributes();
}
