/**
 * <copyright>
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package VOCLModel.impl;

import VOCLModel.Attribute;
import VOCLModel.ClassifierNode;
import VOCLModel.Condition;
import VOCLModel.Context;
import VOCLModel.LetExp;
import VOCLModel.Method;
import VOCLModel.NavExp;
import VOCLModel.OpKindEnum;
import VOCLModel.VOCLModelPackage;
import VOCLModel.VariableDeclaration;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Variable Declaration</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link VOCLModel.impl.VariableDeclarationImpl#getVarName <em>Var Name</em>}</li>
 *   <li>{@link VOCLModel.impl.VariableDeclarationImpl#getType <em>Type</em>}</li>
 *   <li>{@link VOCLModel.impl.VariableDeclarationImpl#getLeftCondition <em>Left Condition</em>}</li>
 *   <li>{@link VOCLModel.impl.VariableDeclarationImpl#getRightCondition <em>Right Condition</em>}</li>
 *   <li>{@link VOCLModel.impl.VariableDeclarationImpl#getContext <em>Context</em>}</li>
 *   <li>{@link VOCLModel.impl.VariableDeclarationImpl#getLetExp <em>Let Exp</em>}</li>
 *   <li>{@link VOCLModel.impl.VariableDeclarationImpl#getOpKindEnumCall <em>Op Kind Enum Call</em>}</li>
 *   <li>{@link VOCLModel.impl.VariableDeclarationImpl#getOpKindEnumIterator <em>Op Kind Enum Iterator</em>}</li>
 *   <li>{@link VOCLModel.impl.VariableDeclarationImpl#getMethodCall <em>Method Call</em>}</li>
 *   <li>{@link VOCLModel.impl.VariableDeclarationImpl#getMethodReturns <em>Method Returns</em>}</li>
 *   <li>{@link VOCLModel.impl.VariableDeclarationImpl#getClassifierNode <em>Classifier Node</em>}</li>
 *   <li>{@link VOCLModel.impl.VariableDeclarationImpl#getAttribute <em>Attribute</em>}</li>
 *   <li>{@link VOCLModel.impl.VariableDeclarationImpl#getNavExp <em>Nav Exp</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class VariableDeclarationImpl extends EObjectImpl implements VariableDeclaration
{
  /**
   * The default value of the '{@link #getVarName() <em>Var Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getVarName()
   * @generated
   * @ordered
   */
  protected static final String VAR_NAME_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getVarName() <em>Var Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getVarName()
   * @generated
   * @ordered
   */
  protected String varName = VAR_NAME_EDEFAULT;

  /**
   * The default value of the '{@link #getType() <em>Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getType()
   * @generated
   * @ordered
   */
  protected static final String TYPE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getType() <em>Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getType()
   * @generated
   * @ordered
   */
  protected String type = TYPE_EDEFAULT;

  /**
   * The cached value of the '{@link #getLeftCondition() <em>Left Condition</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLeftCondition()
   * @generated
   * @ordered
   */
  protected EList leftCondition = null;

  /**
   * The cached value of the '{@link #getRightCondition() <em>Right Condition</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRightCondition()
   * @generated
   * @ordered
   */
  protected Condition rightCondition = null;

  /**
   * The cached value of the '{@link #getOpKindEnumCall() <em>Op Kind Enum Call</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getOpKindEnumCall()
   * @generated
   * @ordered
   */
  protected EList opKindEnumCall = null;

  /**
   * The cached value of the '{@link #getOpKindEnumIterator() <em>Op Kind Enum Iterator</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getOpKindEnumIterator()
   * @generated
   * @ordered
   */
  protected EList opKindEnumIterator = null;

  /**
   * The cached value of the '{@link #getMethodCall() <em>Method Call</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMethodCall()
   * @generated
   * @ordered
   */
  protected Method methodCall = null;

  /**
   * The cached value of the '{@link #getMethodReturns() <em>Method Returns</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMethodReturns()
   * @generated
   * @ordered
   */
  protected Method methodReturns = null;

  /**
   * The cached value of the '{@link #getClassifierNode() <em>Classifier Node</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getClassifierNode()
   * @generated
   * @ordered
   */
  protected EList classifierNode = null;

  /**
   * The cached value of the '{@link #getAttribute() <em>Attribute</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAttribute()
   * @generated
   * @ordered
   */
  protected EList attribute = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected VariableDeclarationImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected EClass eStaticClass()
  {
    return VOCLModelPackage.eINSTANCE.getVariableDeclaration();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getVarName()
  {
    return varName;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setVarName(String newVarName)
  {
    String oldVarName = varName;
    varName = newVarName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, VOCLModelPackage.VARIABLE_DECLARATION__VAR_NAME, oldVarName, varName));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getType()
  {
    return type;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setType(String newType)
  {
    String oldType = type;
    type = newType;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, VOCLModelPackage.VARIABLE_DECLARATION__TYPE, oldType, type));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList getLeftCondition()
  {
    if (leftCondition == null)
    {
      leftCondition = new EObjectWithInverseResolvingEList(Condition.class, this, VOCLModelPackage.VARIABLE_DECLARATION__LEFT_CONDITION, VOCLModelPackage.CONDITION__LEFT);
    }
    return leftCondition;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Condition getRightCondition()
  {
    if (rightCondition != null && rightCondition.eIsProxy())
    {
      Condition oldRightCondition = rightCondition;
      rightCondition = (Condition)EcoreUtil.resolve(rightCondition, this);
      if (rightCondition != oldRightCondition)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, VOCLModelPackage.VARIABLE_DECLARATION__RIGHT_CONDITION, oldRightCondition, rightCondition));
      }
    }
    return rightCondition;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Condition basicGetRightCondition()
  {
    return rightCondition;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetRightCondition(Condition newRightCondition, NotificationChain msgs)
  {
    Condition oldRightCondition = rightCondition;
    rightCondition = newRightCondition;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, VOCLModelPackage.VARIABLE_DECLARATION__RIGHT_CONDITION, oldRightCondition, newRightCondition);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setRightCondition(Condition newRightCondition)
  {
    if (newRightCondition != rightCondition)
    {
      NotificationChain msgs = null;
      if (rightCondition != null)
        msgs = ((InternalEObject)rightCondition).eInverseRemove(this, VOCLModelPackage.CONDITION__RIGHT, Condition.class, msgs);
      if (newRightCondition != null)
        msgs = ((InternalEObject)newRightCondition).eInverseAdd(this, VOCLModelPackage.CONDITION__RIGHT, Condition.class, msgs);
      msgs = basicSetRightCondition(newRightCondition, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, VOCLModelPackage.VARIABLE_DECLARATION__RIGHT_CONDITION, newRightCondition, newRightCondition));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Context getContext()
  {
    if (eContainerFeatureID != VOCLModelPackage.VARIABLE_DECLARATION__CONTEXT) return null;
    return (Context)eContainer;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setContext(Context newContext)
  {
    if (newContext != eContainer || (eContainerFeatureID != VOCLModelPackage.VARIABLE_DECLARATION__CONTEXT && newContext != null))
    {
      if (EcoreUtil.isAncestor(this, newContext))
        throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
      NotificationChain msgs = null;
      if (eContainer != null)
        msgs = eBasicRemoveFromContainer(msgs);
      if (newContext != null)
        msgs = ((InternalEObject)newContext).eInverseAdd(this, VOCLModelPackage.CONTEXT__VARIABLE_DECLARATION, Context.class, msgs);
      msgs = eBasicSetContainer((InternalEObject)newContext, VOCLModelPackage.VARIABLE_DECLARATION__CONTEXT, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, VOCLModelPackage.VARIABLE_DECLARATION__CONTEXT, newContext, newContext));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public LetExp getLetExp()
  {
    if (eContainerFeatureID != VOCLModelPackage.VARIABLE_DECLARATION__LET_EXP) return null;
    return (LetExp)eContainer;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setLetExp(LetExp newLetExp)
  {
    if (newLetExp != eContainer || (eContainerFeatureID != VOCLModelPackage.VARIABLE_DECLARATION__LET_EXP && newLetExp != null))
    {
      if (EcoreUtil.isAncestor(this, newLetExp))
        throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
      NotificationChain msgs = null;
      if (eContainer != null)
        msgs = eBasicRemoveFromContainer(msgs);
      if (newLetExp != null)
        msgs = ((InternalEObject)newLetExp).eInverseAdd(this, VOCLModelPackage.LET_EXP__VARIABLE_DECLARATION, LetExp.class, msgs);
      msgs = eBasicSetContainer((InternalEObject)newLetExp, VOCLModelPackage.VARIABLE_DECLARATION__LET_EXP, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, VOCLModelPackage.VARIABLE_DECLARATION__LET_EXP, newLetExp, newLetExp));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList getOpKindEnumCall()
  {
    if (opKindEnumCall == null)
    {
      opKindEnumCall = new EObjectWithInverseResolvingEList(OpKindEnum.class, this, VOCLModelPackage.VARIABLE_DECLARATION__OP_KIND_ENUM_CALL, VOCLModelPackage.OP_KIND_ENUM__CALL_VAR);
    }
    return opKindEnumCall;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList getOpKindEnumIterator()
  {
    if (opKindEnumIterator == null)
    {
      opKindEnumIterator = new EObjectWithInverseResolvingEList(OpKindEnum.class, this, VOCLModelPackage.VARIABLE_DECLARATION__OP_KIND_ENUM_ITERATOR, VOCLModelPackage.OP_KIND_ENUM__ITERATOR_VAR);
    }
    return opKindEnumIterator;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Method getMethodCall()
  {
    if (methodCall != null && methodCall.eIsProxy())
    {
      Method oldMethodCall = methodCall;
      methodCall = (Method)EcoreUtil.resolve(methodCall, this);
      if (methodCall != oldMethodCall)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, VOCLModelPackage.VARIABLE_DECLARATION__METHOD_CALL, oldMethodCall, methodCall));
      }
    }
    return methodCall;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Method basicGetMethodCall()
  {
    return methodCall;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetMethodCall(Method newMethodCall, NotificationChain msgs)
  {
    Method oldMethodCall = methodCall;
    methodCall = newMethodCall;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, VOCLModelPackage.VARIABLE_DECLARATION__METHOD_CALL, oldMethodCall, newMethodCall);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMethodCall(Method newMethodCall)
  {
    if (newMethodCall != methodCall)
    {
      NotificationChain msgs = null;
      if (methodCall != null)
        msgs = ((InternalEObject)methodCall).eInverseRemove(this, VOCLModelPackage.METHOD__CALL, Method.class, msgs);
      if (newMethodCall != null)
        msgs = ((InternalEObject)newMethodCall).eInverseAdd(this, VOCLModelPackage.METHOD__CALL, Method.class, msgs);
      msgs = basicSetMethodCall(newMethodCall, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, VOCLModelPackage.VARIABLE_DECLARATION__METHOD_CALL, newMethodCall, newMethodCall));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Method getMethodReturns()
  {
    if (methodReturns != null && methodReturns.eIsProxy())
    {
      Method oldMethodReturns = methodReturns;
      methodReturns = (Method)EcoreUtil.resolve(methodReturns, this);
      if (methodReturns != oldMethodReturns)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, VOCLModelPackage.VARIABLE_DECLARATION__METHOD_RETURNS, oldMethodReturns, methodReturns));
      }
    }
    return methodReturns;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Method basicGetMethodReturns()
  {
    return methodReturns;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetMethodReturns(Method newMethodReturns, NotificationChain msgs)
  {
    Method oldMethodReturns = methodReturns;
    methodReturns = newMethodReturns;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, VOCLModelPackage.VARIABLE_DECLARATION__METHOD_RETURNS, oldMethodReturns, newMethodReturns);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMethodReturns(Method newMethodReturns)
  {
    if (newMethodReturns != methodReturns)
    {
      NotificationChain msgs = null;
      if (methodReturns != null)
        msgs = ((InternalEObject)methodReturns).eInverseRemove(this, VOCLModelPackage.METHOD__RETURNS, Method.class, msgs);
      if (newMethodReturns != null)
        msgs = ((InternalEObject)newMethodReturns).eInverseAdd(this, VOCLModelPackage.METHOD__RETURNS, Method.class, msgs);
      msgs = basicSetMethodReturns(newMethodReturns, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, VOCLModelPackage.VARIABLE_DECLARATION__METHOD_RETURNS, newMethodReturns, newMethodReturns));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList getClassifierNode()
  {
    if (classifierNode == null)
    {
      classifierNode = new EObjectWithInverseResolvingEList(ClassifierNode.class, this, VOCLModelPackage.VARIABLE_DECLARATION__CLASSIFIER_NODE, VOCLModelPackage.CLASSIFIER_NODE__CLASSIFIER_VAR);
    }
    return classifierNode;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList getAttribute()
  {
    if (attribute == null)
    {
      attribute = new EObjectWithInverseResolvingEList(Attribute.class, this, VOCLModelPackage.VARIABLE_DECLARATION__ATTRIBUTE, VOCLModelPackage.ATTRIBUTE__VARIABLE_DECLARATION);
    }
    return attribute;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NavExp getNavExp()
  {
    if (eContainerFeatureID != VOCLModelPackage.VARIABLE_DECLARATION__NAV_EXP) return null;
    return (NavExp)eContainer;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setNavExp(NavExp newNavExp)
  {
    if (newNavExp != eContainer || (eContainerFeatureID != VOCLModelPackage.VARIABLE_DECLARATION__NAV_EXP && newNavExp != null))
    {
      if (EcoreUtil.isAncestor(this, newNavExp))
        throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
      NotificationChain msgs = null;
      if (eContainer != null)
        msgs = eBasicRemoveFromContainer(msgs);
      if (newNavExp != null)
        msgs = ((InternalEObject)newNavExp).eInverseAdd(this, VOCLModelPackage.NAV_EXP__VARIABLE_DECLARATION, NavExp.class, msgs);
      msgs = eBasicSetContainer((InternalEObject)newNavExp, VOCLModelPackage.VARIABLE_DECLARATION__NAV_EXP, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, VOCLModelPackage.VARIABLE_DECLARATION__NAV_EXP, newNavExp, newNavExp));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs)
  {
    if (featureID >= 0)
    {
      switch (eDerivedStructuralFeatureID(featureID, baseClass))
      {
        case VOCLModelPackage.VARIABLE_DECLARATION__LEFT_CONDITION:
          return ((InternalEList)getLeftCondition()).basicAdd(otherEnd, msgs);
        case VOCLModelPackage.VARIABLE_DECLARATION__RIGHT_CONDITION:
          if (rightCondition != null)
            msgs = ((InternalEObject)rightCondition).eInverseRemove(this, VOCLModelPackage.CONDITION__RIGHT, Condition.class, msgs);
          return basicSetRightCondition((Condition)otherEnd, msgs);
        case VOCLModelPackage.VARIABLE_DECLARATION__CONTEXT:
          if (eContainer != null)
            msgs = eBasicRemoveFromContainer(msgs);
          return eBasicSetContainer(otherEnd, VOCLModelPackage.VARIABLE_DECLARATION__CONTEXT, msgs);
        case VOCLModelPackage.VARIABLE_DECLARATION__LET_EXP:
          if (eContainer != null)
            msgs = eBasicRemoveFromContainer(msgs);
          return eBasicSetContainer(otherEnd, VOCLModelPackage.VARIABLE_DECLARATION__LET_EXP, msgs);
        case VOCLModelPackage.VARIABLE_DECLARATION__OP_KIND_ENUM_CALL:
          return ((InternalEList)getOpKindEnumCall()).basicAdd(otherEnd, msgs);
        case VOCLModelPackage.VARIABLE_DECLARATION__OP_KIND_ENUM_ITERATOR:
          return ((InternalEList)getOpKindEnumIterator()).basicAdd(otherEnd, msgs);
        case VOCLModelPackage.VARIABLE_DECLARATION__METHOD_CALL:
          if (methodCall != null)
            msgs = ((InternalEObject)methodCall).eInverseRemove(this, VOCLModelPackage.METHOD__CALL, Method.class, msgs);
          return basicSetMethodCall((Method)otherEnd, msgs);
        case VOCLModelPackage.VARIABLE_DECLARATION__METHOD_RETURNS:
          if (methodReturns != null)
            msgs = ((InternalEObject)methodReturns).eInverseRemove(this, VOCLModelPackage.METHOD__RETURNS, Method.class, msgs);
          return basicSetMethodReturns((Method)otherEnd, msgs);
        case VOCLModelPackage.VARIABLE_DECLARATION__CLASSIFIER_NODE:
          return ((InternalEList)getClassifierNode()).basicAdd(otherEnd, msgs);
        case VOCLModelPackage.VARIABLE_DECLARATION__ATTRIBUTE:
          return ((InternalEList)getAttribute()).basicAdd(otherEnd, msgs);
        case VOCLModelPackage.VARIABLE_DECLARATION__NAV_EXP:
          if (eContainer != null)
            msgs = eBasicRemoveFromContainer(msgs);
          return eBasicSetContainer(otherEnd, VOCLModelPackage.VARIABLE_DECLARATION__NAV_EXP, msgs);
        default:
          return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
      }
    }
    if (eContainer != null)
      msgs = eBasicRemoveFromContainer(msgs);
    return eBasicSetContainer(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs)
  {
    if (featureID >= 0)
    {
      switch (eDerivedStructuralFeatureID(featureID, baseClass))
      {
        case VOCLModelPackage.VARIABLE_DECLARATION__LEFT_CONDITION:
          return ((InternalEList)getLeftCondition()).basicRemove(otherEnd, msgs);
        case VOCLModelPackage.VARIABLE_DECLARATION__RIGHT_CONDITION:
          return basicSetRightCondition(null, msgs);
        case VOCLModelPackage.VARIABLE_DECLARATION__CONTEXT:
          return eBasicSetContainer(null, VOCLModelPackage.VARIABLE_DECLARATION__CONTEXT, msgs);
        case VOCLModelPackage.VARIABLE_DECLARATION__LET_EXP:
          return eBasicSetContainer(null, VOCLModelPackage.VARIABLE_DECLARATION__LET_EXP, msgs);
        case VOCLModelPackage.VARIABLE_DECLARATION__OP_KIND_ENUM_CALL:
          return ((InternalEList)getOpKindEnumCall()).basicRemove(otherEnd, msgs);
        case VOCLModelPackage.VARIABLE_DECLARATION__OP_KIND_ENUM_ITERATOR:
          return ((InternalEList)getOpKindEnumIterator()).basicRemove(otherEnd, msgs);
        case VOCLModelPackage.VARIABLE_DECLARATION__METHOD_CALL:
          return basicSetMethodCall(null, msgs);
        case VOCLModelPackage.VARIABLE_DECLARATION__METHOD_RETURNS:
          return basicSetMethodReturns(null, msgs);
        case VOCLModelPackage.VARIABLE_DECLARATION__CLASSIFIER_NODE:
          return ((InternalEList)getClassifierNode()).basicRemove(otherEnd, msgs);
        case VOCLModelPackage.VARIABLE_DECLARATION__ATTRIBUTE:
          return ((InternalEList)getAttribute()).basicRemove(otherEnd, msgs);
        case VOCLModelPackage.VARIABLE_DECLARATION__NAV_EXP:
          return eBasicSetContainer(null, VOCLModelPackage.VARIABLE_DECLARATION__NAV_EXP, msgs);
        default:
          return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
      }
    }
    return eBasicSetContainer(null, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs)
  {
    if (eContainerFeatureID >= 0)
    {
      switch (eContainerFeatureID)
      {
        case VOCLModelPackage.VARIABLE_DECLARATION__CONTEXT:
          return ((InternalEObject)eContainer).eInverseRemove(this, VOCLModelPackage.CONTEXT__VARIABLE_DECLARATION, Context.class, msgs);
        case VOCLModelPackage.VARIABLE_DECLARATION__LET_EXP:
          return ((InternalEObject)eContainer).eInverseRemove(this, VOCLModelPackage.LET_EXP__VARIABLE_DECLARATION, LetExp.class, msgs);
        case VOCLModelPackage.VARIABLE_DECLARATION__NAV_EXP:
          return ((InternalEObject)eContainer).eInverseRemove(this, VOCLModelPackage.NAV_EXP__VARIABLE_DECLARATION, NavExp.class, msgs);
        default:
          return eDynamicBasicRemoveFromContainer(msgs);
      }
    }
    return ((InternalEObject)eContainer).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Object eGet(EStructuralFeature eFeature, boolean resolve)
  {
    switch (eDerivedStructuralFeatureID(eFeature))
    {
      case VOCLModelPackage.VARIABLE_DECLARATION__VAR_NAME:
        return getVarName();
      case VOCLModelPackage.VARIABLE_DECLARATION__TYPE:
        return getType();
      case VOCLModelPackage.VARIABLE_DECLARATION__LEFT_CONDITION:
        return getLeftCondition();
      case VOCLModelPackage.VARIABLE_DECLARATION__RIGHT_CONDITION:
        if (resolve) return getRightCondition();
        return basicGetRightCondition();
      case VOCLModelPackage.VARIABLE_DECLARATION__CONTEXT:
        return getContext();
      case VOCLModelPackage.VARIABLE_DECLARATION__LET_EXP:
        return getLetExp();
      case VOCLModelPackage.VARIABLE_DECLARATION__OP_KIND_ENUM_CALL:
        return getOpKindEnumCall();
      case VOCLModelPackage.VARIABLE_DECLARATION__OP_KIND_ENUM_ITERATOR:
        return getOpKindEnumIterator();
      case VOCLModelPackage.VARIABLE_DECLARATION__METHOD_CALL:
        if (resolve) return getMethodCall();
        return basicGetMethodCall();
      case VOCLModelPackage.VARIABLE_DECLARATION__METHOD_RETURNS:
        if (resolve) return getMethodReturns();
        return basicGetMethodReturns();
      case VOCLModelPackage.VARIABLE_DECLARATION__CLASSIFIER_NODE:
        return getClassifierNode();
      case VOCLModelPackage.VARIABLE_DECLARATION__ATTRIBUTE:
        return getAttribute();
      case VOCLModelPackage.VARIABLE_DECLARATION__NAV_EXP:
        return getNavExp();
    }
    return eDynamicGet(eFeature, resolve);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void eSet(EStructuralFeature eFeature, Object newValue)
  {
    switch (eDerivedStructuralFeatureID(eFeature))
    {
      case VOCLModelPackage.VARIABLE_DECLARATION__VAR_NAME:
        setVarName((String)newValue);
        return;
      case VOCLModelPackage.VARIABLE_DECLARATION__TYPE:
        setType((String)newValue);
        return;
      case VOCLModelPackage.VARIABLE_DECLARATION__LEFT_CONDITION:
        getLeftCondition().clear();
        getLeftCondition().addAll((Collection)newValue);
        return;
      case VOCLModelPackage.VARIABLE_DECLARATION__RIGHT_CONDITION:
        setRightCondition((Condition)newValue);
        return;
      case VOCLModelPackage.VARIABLE_DECLARATION__CONTEXT:
        setContext((Context)newValue);
        return;
      case VOCLModelPackage.VARIABLE_DECLARATION__LET_EXP:
        setLetExp((LetExp)newValue);
        return;
      case VOCLModelPackage.VARIABLE_DECLARATION__OP_KIND_ENUM_CALL:
        getOpKindEnumCall().clear();
        getOpKindEnumCall().addAll((Collection)newValue);
        return;
      case VOCLModelPackage.VARIABLE_DECLARATION__OP_KIND_ENUM_ITERATOR:
        getOpKindEnumIterator().clear();
        getOpKindEnumIterator().addAll((Collection)newValue);
        return;
      case VOCLModelPackage.VARIABLE_DECLARATION__METHOD_CALL:
        setMethodCall((Method)newValue);
        return;
      case VOCLModelPackage.VARIABLE_DECLARATION__METHOD_RETURNS:
        setMethodReturns((Method)newValue);
        return;
      case VOCLModelPackage.VARIABLE_DECLARATION__CLASSIFIER_NODE:
        getClassifierNode().clear();
        getClassifierNode().addAll((Collection)newValue);
        return;
      case VOCLModelPackage.VARIABLE_DECLARATION__ATTRIBUTE:
        getAttribute().clear();
        getAttribute().addAll((Collection)newValue);
        return;
      case VOCLModelPackage.VARIABLE_DECLARATION__NAV_EXP:
        setNavExp((NavExp)newValue);
        return;
    }
    eDynamicSet(eFeature, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void eUnset(EStructuralFeature eFeature)
  {
    switch (eDerivedStructuralFeatureID(eFeature))
    {
      case VOCLModelPackage.VARIABLE_DECLARATION__VAR_NAME:
        setVarName(VAR_NAME_EDEFAULT);
        return;
      case VOCLModelPackage.VARIABLE_DECLARATION__TYPE:
        setType(TYPE_EDEFAULT);
        return;
      case VOCLModelPackage.VARIABLE_DECLARATION__LEFT_CONDITION:
        getLeftCondition().clear();
        return;
      case VOCLModelPackage.VARIABLE_DECLARATION__RIGHT_CONDITION:
        setRightCondition((Condition)null);
        return;
      case VOCLModelPackage.VARIABLE_DECLARATION__CONTEXT:
        setContext((Context)null);
        return;
      case VOCLModelPackage.VARIABLE_DECLARATION__LET_EXP:
        setLetExp((LetExp)null);
        return;
      case VOCLModelPackage.VARIABLE_DECLARATION__OP_KIND_ENUM_CALL:
        getOpKindEnumCall().clear();
        return;
      case VOCLModelPackage.VARIABLE_DECLARATION__OP_KIND_ENUM_ITERATOR:
        getOpKindEnumIterator().clear();
        return;
      case VOCLModelPackage.VARIABLE_DECLARATION__METHOD_CALL:
        setMethodCall((Method)null);
        return;
      case VOCLModelPackage.VARIABLE_DECLARATION__METHOD_RETURNS:
        setMethodReturns((Method)null);
        return;
      case VOCLModelPackage.VARIABLE_DECLARATION__CLASSIFIER_NODE:
        getClassifierNode().clear();
        return;
      case VOCLModelPackage.VARIABLE_DECLARATION__ATTRIBUTE:
        getAttribute().clear();
        return;
      case VOCLModelPackage.VARIABLE_DECLARATION__NAV_EXP:
        setNavExp((NavExp)null);
        return;
    }
    eDynamicUnset(eFeature);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean eIsSet(EStructuralFeature eFeature)
  {
    switch (eDerivedStructuralFeatureID(eFeature))
    {
      case VOCLModelPackage.VARIABLE_DECLARATION__VAR_NAME:
        return VAR_NAME_EDEFAULT == null ? varName != null : !VAR_NAME_EDEFAULT.equals(varName);
      case VOCLModelPackage.VARIABLE_DECLARATION__TYPE:
        return TYPE_EDEFAULT == null ? type != null : !TYPE_EDEFAULT.equals(type);
      case VOCLModelPackage.VARIABLE_DECLARATION__LEFT_CONDITION:
        return leftCondition != null && !leftCondition.isEmpty();
      case VOCLModelPackage.VARIABLE_DECLARATION__RIGHT_CONDITION:
        return rightCondition != null;
      case VOCLModelPackage.VARIABLE_DECLARATION__CONTEXT:
        return getContext() != null;
      case VOCLModelPackage.VARIABLE_DECLARATION__LET_EXP:
        return getLetExp() != null;
      case VOCLModelPackage.VARIABLE_DECLARATION__OP_KIND_ENUM_CALL:
        return opKindEnumCall != null && !opKindEnumCall.isEmpty();
      case VOCLModelPackage.VARIABLE_DECLARATION__OP_KIND_ENUM_ITERATOR:
        return opKindEnumIterator != null && !opKindEnumIterator.isEmpty();
      case VOCLModelPackage.VARIABLE_DECLARATION__METHOD_CALL:
        return methodCall != null;
      case VOCLModelPackage.VARIABLE_DECLARATION__METHOD_RETURNS:
        return methodReturns != null;
      case VOCLModelPackage.VARIABLE_DECLARATION__CLASSIFIER_NODE:
        return classifierNode != null && !classifierNode.isEmpty();
      case VOCLModelPackage.VARIABLE_DECLARATION__ATTRIBUTE:
        return attribute != null && !attribute.isEmpty();
      case VOCLModelPackage.VARIABLE_DECLARATION__NAV_EXP:
        return getNavExp() != null;
    }
    return eDynamicIsSet(eFeature);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (varName: ");
    result.append(varName);
    result.append(", type: ");
    result.append(type);
    result.append(")");
    return result.toString();
  }

} //VariableDeclarationImpl
