package vocleditor.dialogs;

import java.util.Vector;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.VerifyEvent;
import org.eclipse.swt.events.VerifyListener;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;


/**
* This code was generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* *************************************
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED
* for this machine, so Jigloo or this code cannot be used legally
* for any corporate or commercial purpose.
* *************************************
*/
/**
 * 
 * Class       : NewMethodDialog<br/>
 * Package     : vocleditor.dialog<br/>
 * Project     : VOCLEditor<br/>
 * Created On  : 26.06.2004<br/>
 * Description : This class provides a dialog for creating a method for a ClassifierRole<br/>
 * @author Gruppe 1: Stefan Hnsgen, 
 * 					 Andre Hernich,
 * 			 		 Maximilian Kern,
 *		 			 Sebastian Russin<br>
 */
public class NewMethodDialog extends org.eclipse.swt.widgets.Dialog {
	private Button Cancel;
	private TableColumn ParameterTyp;
	private TableColumn Parameter;
	private Button ok;
	private Button removeButton;
	private Button editButton;
	private Label label4;
	private Button addButton;
	private Table parameterDecl;
	private Label label3;
	private Text text2;
	private Text text1;
	private Button resultButton;
	private Label label1;
	private Text methodName;
	private Shell dialogShell;
	private CreateNewClassifierRoleSimpleDialog parentDialog;

	private boolean hasReturnType = false;
	private String method_Name = "";
	private String result_Name = "";
	private String result_Type = "";
	private Vector parameters = new Vector();
	private boolean cancelled = false;
	
	/**
	 * Constructor.
	 * @param parent
	 * @param style
	 * @param dialog
	 */
	public NewMethodDialog(
		Shell parent,
		int style,
		CreateNewClassifierRoleSimpleDialog dialog) {
		super(parent, style);
		parentDialog = dialog;
	}

	/**
	* Opens the Dialog Shell.
	* Auto-generated code - any changes you make will disappear.
	*/
	public void open(){
		try {
			preInitGUI();
	
			Shell parent = getParent();
			dialogShell = new Shell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
			dialogShell.setText(getText());
			methodName = new Text(dialogShell,SWT.NULL);
			label1 = new Label(dialogShell,SWT.NULL);
			resultButton = new Button(dialogShell,SWT.CHECK| SWT.LEFT);
			text1 = new Text(dialogShell,SWT.NULL);
			text2 = new Text(dialogShell,SWT.NULL);
			label3 = new Label(dialogShell,SWT.NULL);
			parameterDecl = new Table(dialogShell,SWT.NULL);
			Parameter = new TableColumn(parameterDecl,SWT.NULL);
			ParameterTyp = new TableColumn(parameterDecl,SWT.NULL);
			addButton = new Button(dialogShell,SWT.PUSH| SWT.CENTER);
			label4 = new Label(dialogShell,SWT.NULL);
			editButton = new Button(dialogShell,SWT.PUSH| SWT.CENTER);
			removeButton = new Button(dialogShell,SWT.PUSH| SWT.CENTER);
			ok = new Button(dialogShell,SWT.PUSH| SWT.CENTER);
			Cancel = new Button(dialogShell,SWT.PUSH| SWT.CENTER);
	
			dialogShell.setText("Methodenaufruf erstellen");
			dialogShell.setSize(new org.eclipse.swt.graphics.Point(341,248));
	
			methodName.setSize(new org.eclipse.swt.graphics.Point(78,15));
			methodName.setBounds(new org.eclipse.swt.graphics.Rectangle(97,24,84,15));
			methodName.addVerifyListener( new VerifyListener() {
				public void verifyText(VerifyEvent evt) {
					methodNameVerifyText(evt);
				}
			});
	
			label1.setText("Methodenname:");
			label1.setSize(new org.eclipse.swt.graphics.Point(84,15));
			label1.setBounds(new org.eclipse.swt.graphics.Rectangle(10,24,84,15));
	
			resultButton.setText("mit Rckgabewert");
			resultButton.setSelection(false);
			resultButton.setSize(new org.eclipse.swt.graphics.Point(116,27));
			resultButton.setBounds(new org.eclipse.swt.graphics.Rectangle(12,46,116,27));
			resultButton.addSelectionListener( new SelectionAdapter() {
				public void widgetSelected(SelectionEvent evt) {
					resultButtonWidgetSelected(evt);
				}
			});
	
			text1.setSize(new org.eclipse.swt.graphics.Point(78,15));
			text1.setEnabled(false);
			text1.setBounds(new org.eclipse.swt.graphics.Rectangle(56,76,84,15));
	
			text2.setSize(new org.eclipse.swt.graphics.Point(78,15));
			text2.setEnabled(false);
			text2.setBounds(new org.eclipse.swt.graphics.Rectangle(202,76,84,15));
	
			label3.setText("Typ:");
			label3.setSize(new org.eclipse.swt.graphics.Point(36,18));
			label3.setEnabled(true);
			label3.setBounds(new org.eclipse.swt.graphics.Rectangle(160,76,36,18));
	
			parameterDecl.setHeaderVisible(true);
			parameterDecl.setLinesVisible(true);
			parameterDecl.setSize(new org.eclipse.swt.graphics.Point(196,78));
			parameterDecl.setLocation(new org.eclipse.swt.graphics.Point(0,0));
			parameterDecl.setBounds(new org.eclipse.swt.graphics.Rectangle(14,110,213,95));
	
			Parameter.setText("Parameter");
			Parameter.setWidth(64);
	
			ParameterTyp.setText("ParameterTyp");
			ParameterTyp.setWidth(150);
	
			addButton.setText("Hinzufgen");
			addButton.setSize(new org.eclipse.swt.graphics.Point(70,25));
			addButton.setBounds(new org.eclipse.swt.graphics.Rectangle(250,110,70,25));
			addButton.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					addButtonMouseDown(evt);
				}
			});
	
			label4.setText("Name:");
			label4.setSize(new org.eclipse.swt.graphics.Point(36,18));
			label4.setEnabled(true);
			label4.setBounds(new org.eclipse.swt.graphics.Rectangle(14,76,36,18));
	
			editButton.setText("Bearbeiten");
			editButton.setSize(new org.eclipse.swt.graphics.Point(70,25));
			editButton.setEnabled(false);
			editButton.setBounds(new org.eclipse.swt.graphics.Rectangle(250,140,70,25));
			editButton.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					editButtonMouseDown(evt);
				}
			});
	
			removeButton.setText("Entfernen");
			removeButton.setSize(new org.eclipse.swt.graphics.Point(70,25));
			removeButton.setEnabled(false);
			removeButton.setBounds(new org.eclipse.swt.graphics.Rectangle(250,170,70,25));
			removeButton.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					removeButtonMouseDown(evt);
				}
			});
	
			ok.setText("Ok");
			ok.setSize(new org.eclipse.swt.graphics.Point(60,30));
			ok.setBounds(new org.eclipse.swt.graphics.Rectangle(19,214,60,30));
			ok.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					okMouseDown(evt);
				}
			});
	
			Cancel.setText("Cancel");
			Cancel.setSize(new org.eclipse.swt.graphics.Point(60,30));
			Cancel.setBounds(new org.eclipse.swt.graphics.Rectangle(89,214,60,30));
			Cancel.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					CancelMouseDown(evt);
				}
			});
			dialogShell.setLayout(null);
			Rectangle bounds = dialogShell.computeTrim(0, 0, 341,248);
			dialogShell.setSize(bounds.width, bounds.height);
			postInitGUI();
			dialogShell.open();
			Display display = dialogShell.getDisplay();
			while (!dialogShell.isDisposed()) {
				if (!display.readAndDispatch())
					display.sleep();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	/** Add your pre-init code in here 	*/
	public void preInitGUI() {
	}

	/** Add your post-init code in here 	*/
	public void postInitGUI() {
		label3.setVisible(false);
		label4.setVisible(false);
	}

	
	/** Auto-generated event handler method */
	protected void addButtonMouseDown(MouseEvent evt) {
		//opens dialog for creating / editing parameters
		ParameterDialog d = new ParameterDialog(dialogShell, SWT.NULL, this);
		d.open();
		if (d.isCancelled()) {
			return;
		}
		
		if (d.getParameter() != null) {
			TableItem tableItem = new TableItem(parameterDecl, SWT.NULL);
			String pName = (String) d.getParameter().elementAt(0);
			String pType = (String) d.getParameter().elementAt(1);
			tableItem.setText(0, pName);
			tableItem.setText(1, pType);
			parameters.add(pName);
			parameters.add(pType);
		}
		
		editButton.setEnabled(parameterDecl.getItemCount() != 0);
		removeButton.setEnabled(parameterDecl.getItemCount() != 0);
	}

	/** Auto-generated event handler method */
	protected void editButtonMouseDown(MouseEvent evt) {
		ParameterDialog d = new ParameterDialog(dialogShell, SWT.NULL, this);
		int index = parameterDecl.getSelectionIndex();
		if (index > -1) {
			TableItem item = parameterDecl.getItem(index);
			Vector params = new Vector();
			params.add(item.getText(0));
			params.add(item.getText(1));
			d.setParameter(params);
			int i1 = parameters.indexOf(item.getText(0));
			int i2 = parameters.indexOf(item.getText(1));
			d.open();
			
			params = d.getParameter();
			item.setText(0,(String)params.elementAt(0));
			item.setText(1,(String)params.elementAt(1));
			parameters.set(i1,(String)params.elementAt(0));
			parameters.set(i2,(String)params.elementAt(1));
		}
	}

	/** Auto-generated event handler method */
	protected void removeButtonMouseDown(MouseEvent evt) {
		int index = parameterDecl.getSelectionIndex();
		if (index > -1) {
			TableItem item = parameterDecl.getItem(index);
			String name = item.getText(0);
			String type = item.getText(1);

			for (int i = 0; i < parameters.size(); i += 2) {
				String var = (String) parameters.elementAt(i);
				if (var.equals(name)) {
					parameters.remove(i);
					parameters.remove(i);
				}
			}
			parameterDecl.remove(index);
		}
		editButton.setEnabled(parameterDecl.getItemCount() != 0);
		removeButton.setEnabled(parameterDecl.getItemCount() != 0);
	}

	/** Auto-generated event handler method */
	protected void resultButtonWidgetSelected(SelectionEvent evt) {
		label3.setVisible(resultButton.getSelection());
		label4.setVisible(resultButton.getSelection());
		text1.setEnabled(resultButton.getSelection());
		text2.setEnabled(resultButton.getSelection());
		hasReturnType = resultButton.getSelection();
	}

	/** Auto-generated event handler method */
	protected void okMouseDown(MouseEvent evt) {

		method_Name = methodName.getText();
		method_Name.trim();
		if(method_Name.equals("")){
			MessageBox box = new MessageBox(dialogShell,SWT.ICON_INFORMATION);
			box.setMessage("Sie mssen einen Methodennamen eingeben");
			box.open();
			return;
		}
		if (hasReturnType) {
			result_Name = text1.getText();
			result_Type = text2.getText();
		}
		dialogShell.close();
	}

	/** Auto-generated event handler method */
	protected void resultButtonWidgetDefaultSelected(SelectionEvent evt) {
		label3.setEnabled(false);
		label4.setEnabled(false);
		text1.setEnabled(false);
		text2.setEnabled(false);
	}
	/**
	 * Indicates whether the method has a return type or not.
	 * @return hasReturnType
	 */
	public boolean isHasReturnType() {
		return hasReturnType;
	}

	/**
	 * Returns the name of the method.
	 * @return method name
	 */
	public String getMethod_Name() {
		return method_Name;
	}

	/**
	 * Returns the method parameter list.
	 * @return parameters
	 */
	public Vector getParameters() {
		return parameters;
	}

	/**
	 * Return the name of the method return 
	 * @return return name
	 */
	public String getResult_Name() {
		return result_Name;
	}

	/**
	 * Returns the type of the method return.
	 * @return return type
	 */
	public String getResult_Type() {
		return result_Type;
	}


	/** Auto-generated event handler method */
	protected void CancelMouseDown(MouseEvent evt) {
		cancelled = true;
		dialogShell.close();
	}
	/**
	 * Indicates whether this dialog was aborted or not.
	 * @return isCancelled
	 */
	public boolean isCancelled() {
		return cancelled;
	}


	/** Auto-generated event handler method */
	protected void methodNameVerifyText(VerifyEvent evt){
		
	}
}
