package vocleditor.edit;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.ComponentEditPolicy;
import org.eclipse.gef.requests.GroupRequest;

import vocleditor.command.DeleteAssociationRoleCommand;
import VOCLModel.AssociationRole;
/**
 * 
 * Class       : AssociationRoleEditPolicy<br/>
 * Package     : vocleditor.edit<br/>
 * Project     : VOCLEditor<br/>
 * Created On  : 26.06.2004<br/>
 * Description : EditPolicy for delete AssociationRoles.<br/>
 * @author Gruppe 1: Stefan Hnsgen, 
 * 					 Andre Hernich,
 * 			 		 Maximilian Kern,
 *		 			 Sebastian Russin<br>
 */
public class AssociationRoleEditPolicy extends ComponentEditPolicy {

	/**
	 * Create the edit policy.
	 */
	public AssociationRoleEditPolicy() {
		super();
	}

	/* (non-Javadoc)
	 * @see org.eclipse.gef.editpolicies.ComponentEditPolicy#createDeleteCommand(org.eclipse.gef.requests.GroupRequest)
	 */
	protected Command createDeleteCommand(GroupRequest deleteRequest) {
		DeleteAssociationRoleCommand deleteCommand =
			new DeleteAssociationRoleCommand((AssociationRole)getHost().getModel());
		return deleteCommand;
	}

}
