/* 
 * $Id: IModelConverterErrorCodes.java,v 1.2 2004/11/09 09:49:37 haensgen Exp $
 */
 
package VoclToOclConverter;

/**
 * Defines constants used as (error) codes in ModelConverterExceptions.
 * 
 * @see ModelConverterException
 */
public interface IModelConverterErrorCodes {

	/**
	 * OCL converter failed.
	 */
	public static final int OCL_CONVERTER_ERROR = 100;
	
	/**
	 * A constraint has no start role.
	 */
	public static final int CONSTRAINT__NO_START_ROLE = 200;
	
	/**
	 * The method corresponding to the name specified in the context has not been
	 * found. 
	 */
	public static final int CONTEXT__NO_SUCH_METHOD = 300;
}
